import { defineNuxtModule, createResolver, addComponent, addImports, extendViteConfig } from '@nuxt/kit';

const module = defineNuxtModule({
  meta: {
    name: "nuxt-codemirror",
    configKey: "nuxtCodemirror"
  },
  // Default configuration options of the Nuxt module
  defaults: {},
  setup(_options, _nuxt) {
    const { resolve } = createResolver(import.meta.url);
    addComponent({
      name: "NuxtCodeMirror",
      filePath: resolve("./runtime/components/NuxtCodeMirror.vue")
    });
    addImports({
      name: "useNuxtCodeMirror",
      as: "useNuxtCodeMirror",
      from: resolve("./runtime/composables/useNuxtCodeMirror.ts")
    });
    extendViteConfig((config) => {
      config.resolve = config.resolve || {};
      config.resolve.alias = config.resolve.alias || {};
      config.resolve.alias["@codemirror/state"] = resolve(_nuxt.options.rootDir, "node_modules/@codemirror/state");
    });
  }
});

export { module as default };
